// Compiled by ClojureScript 0.0-2138
goog.provide('lt.object');
goog.require('cljs.core');
goog.require('lt.util.dom');
goog.require('lt.util.js');
goog.require('crate.binding');
goog.require('lt.util.js');
goog.require('lt.util.dom');
goog.require('lt.util.cljs');
goog.require('crate.core');
goog.require('lt.util.dom');
goog.require('clojure.string');
goog.require('lt.util.cljs');
goog.require('clojure.set');
goog.require('clojure.string');
goog.require('crate.binding');
goog.require('clojure.set');
goog.require('crate.core');
/**
* Counter to guarantee unique object ids
*/
lt.object.obj_id = cljs.core.atom.call(null,0);
/**
* Map of object ids to objects created by object/create
*/
lt.object.instances = cljs.core.atom.call(null,cljs.core.sorted_map.call(null));
/**
* Map of behavior names to behaviors created by macros/behavior
*/
lt.object.behaviors = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
/**
* Map of object template keys to template maps created by object/object*
*/
lt.object.object_defs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
/**
* Map of tags to associated lists of behaviors
*/
lt.object.tags = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
/**
* Map of tags to dissociated lists of behaviors e.g. :-behavior
*/
lt.object.negated_tags = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
/**
* Metadata of current behavior set during raise and raise-reduce
*/
lt.object._STAR_behavior_meta_STAR_ = null;
lt.object.add = (function add(obj){return cljs.core.swap_BANG_.call(null,lt.object.object_defs,cljs.core.assoc,new cljs.core.Keyword("lt.object","type","lt.object/type",701613666).cljs$core$IFn$_invoke$arity$1(obj),obj);
});
lt.object.add_behavior = (function add_behavior(beh){return cljs.core.swap_BANG_.call(null,lt.object.behaviors,cljs.core.assoc,new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(beh),beh);
});
/**
* Return id of given object
*/
lt.object.__GT_id = (function __GT_id(obj){if(crate.binding.deref_QMARK_.call(null,obj))
{return new cljs.core.Keyword("lt.object","id","lt.object/id",706431105).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj));
} else
{return new cljs.core.Keyword("lt.object","id","lt.object/id",706431105).cljs$core$IFn$_invoke$arity$1(obj);
}
});
lt.object.__GT_behavior_name = (function __GT_behavior_name(beh){if(cljs.core.coll_QMARK_.call(null,beh))
{return cljs.core.first.call(null,beh);
} else
{return beh;
}
});
lt.object.__GT_behavior = (function __GT_behavior(beh){return cljs.core.deref.call(null,lt.object.behaviors).call(null,lt.object.__GT_behavior_name.call(null,beh));
});
lt.object.__GT_triggers = (function __GT_triggers(behs){var result = cljs.core.atom.call(null,cljs.core.transient$.call(null,cljs.core.PersistentArrayMap.EMPTY));var seq__13885_13897 = cljs.core.seq.call(null,behs);var chunk__13890_13898 = null;var count__13891_13899 = 0;var i__13892_13900 = 0;while(true){
if((i__13892_13900 < count__13891_13899))
{var beh_13901 = cljs.core._nth.call(null,chunk__13890_13898,i__13892_13900);var seq__13893_13902 = cljs.core.seq.call(null,new cljs.core.Keyword(null,"triggers","triggers",2516997421).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,beh_13901)));var chunk__13894_13903 = null;var count__13895_13904 = 0;var i__13896_13905 = 0;while(true){
if((i__13896_13905 < count__13895_13904))
{var t_13906 = cljs.core._nth.call(null,chunk__13894_13903,i__13896_13905);cljs.core.swap_BANG_.call(null,result,cljs.core.assoc_BANG_,t_13906,cljs.core.conj.call(null,(function (){var or__3520__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,result),t_13906);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.PersistentVector.EMPTY;
}
})(),beh_13901));
{
var G__13907 = seq__13893_13902;
var G__13908 = chunk__13894_13903;
var G__13909 = count__13895_13904;
var G__13910 = (i__13896_13905 + 1);
seq__13893_13902 = G__13907;
chunk__13894_13903 = G__13908;
count__13895_13904 = G__13909;
i__13896_13905 = G__13910;
continue;
}
} else
{var temp__4092__auto___13911 = cljs.core.seq.call(null,seq__13893_13902);if(temp__4092__auto___13911)
{var seq__13893_13912__$1 = temp__4092__auto___13911;if(cljs.core.chunked_seq_QMARK_.call(null,seq__13893_13912__$1))
{var c__4262__auto___13913 = cljs.core.chunk_first.call(null,seq__13893_13912__$1);{
var G__13914 = cljs.core.chunk_rest.call(null,seq__13893_13912__$1);
var G__13915 = c__4262__auto___13913;
var G__13916 = cljs.core.count.call(null,c__4262__auto___13913);
var G__13917 = 0;
seq__13893_13902 = G__13914;
chunk__13894_13903 = G__13915;
count__13895_13904 = G__13916;
i__13896_13905 = G__13917;
continue;
}
} else
{var t_13918 = cljs.core.first.call(null,seq__13893_13912__$1);cljs.core.swap_BANG_.call(null,result,cljs.core.assoc_BANG_,t_13918,cljs.core.conj.call(null,(function (){var or__3520__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,result),t_13918);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.PersistentVector.EMPTY;
}
})(),beh_13901));
{
var G__13919 = cljs.core.next.call(null,seq__13893_13912__$1);
var G__13920 = null;
var G__13921 = 0;
var G__13922 = 0;
seq__13893_13902 = G__13919;
chunk__13894_13903 = G__13920;
count__13895_13904 = G__13921;
i__13896_13905 = G__13922;
continue;
}
}
} else
{}
}
break;
}
{
var G__13923 = seq__13885_13897;
var G__13924 = chunk__13890_13898;
var G__13925 = count__13891_13899;
var G__13926 = (i__13892_13900 + 1);
seq__13885_13897 = G__13923;
chunk__13890_13898 = G__13924;
count__13891_13899 = G__13925;
i__13892_13900 = G__13926;
continue;
}
} else
{var temp__4092__auto___13927 = cljs.core.seq.call(null,seq__13885_13897);if(temp__4092__auto___13927)
{var seq__13885_13928__$1 = temp__4092__auto___13927;if(cljs.core.chunked_seq_QMARK_.call(null,seq__13885_13928__$1))
{var c__4262__auto___13929 = cljs.core.chunk_first.call(null,seq__13885_13928__$1);{
var G__13930 = cljs.core.chunk_rest.call(null,seq__13885_13928__$1);
var G__13931 = c__4262__auto___13929;
var G__13932 = cljs.core.count.call(null,c__4262__auto___13929);
var G__13933 = 0;
seq__13885_13897 = G__13930;
chunk__13890_13898 = G__13931;
count__13891_13899 = G__13932;
i__13892_13900 = G__13933;
continue;
}
} else
{var beh_13934 = cljs.core.first.call(null,seq__13885_13928__$1);var seq__13886_13935 = cljs.core.seq.call(null,new cljs.core.Keyword(null,"triggers","triggers",2516997421).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,beh_13934)));var chunk__13887_13936 = null;var count__13888_13937 = 0;var i__13889_13938 = 0;while(true){
if((i__13889_13938 < count__13888_13937))
{var t_13939 = cljs.core._nth.call(null,chunk__13887_13936,i__13889_13938);cljs.core.swap_BANG_.call(null,result,cljs.core.assoc_BANG_,t_13939,cljs.core.conj.call(null,(function (){var or__3520__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,result),t_13939);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.PersistentVector.EMPTY;
}
})(),beh_13934));
{
var G__13940 = seq__13886_13935;
var G__13941 = chunk__13887_13936;
var G__13942 = count__13888_13937;
var G__13943 = (i__13889_13938 + 1);
seq__13886_13935 = G__13940;
chunk__13887_13936 = G__13941;
count__13888_13937 = G__13942;
i__13889_13938 = G__13943;
continue;
}
} else
{var temp__4092__auto___13944__$1 = cljs.core.seq.call(null,seq__13886_13935);if(temp__4092__auto___13944__$1)
{var seq__13886_13945__$1 = temp__4092__auto___13944__$1;if(cljs.core.chunked_seq_QMARK_.call(null,seq__13886_13945__$1))
{var c__4262__auto___13946 = cljs.core.chunk_first.call(null,seq__13886_13945__$1);{
var G__13947 = cljs.core.chunk_rest.call(null,seq__13886_13945__$1);
var G__13948 = c__4262__auto___13946;
var G__13949 = cljs.core.count.call(null,c__4262__auto___13946);
var G__13950 = 0;
seq__13886_13935 = G__13947;
chunk__13887_13936 = G__13948;
count__13888_13937 = G__13949;
i__13889_13938 = G__13950;
continue;
}
} else
{var t_13951 = cljs.core.first.call(null,seq__13886_13945__$1);cljs.core.swap_BANG_.call(null,result,cljs.core.assoc_BANG_,t_13951,cljs.core.conj.call(null,(function (){var or__3520__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,result),t_13951);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.PersistentVector.EMPTY;
}
})(),beh_13934));
{
var G__13952 = cljs.core.next.call(null,seq__13886_13945__$1);
var G__13953 = null;
var G__13954 = 0;
var G__13955 = 0;
seq__13886_13935 = G__13952;
chunk__13887_13936 = G__13953;
count__13888_13937 = G__13954;
i__13889_13938 = G__13955;
continue;
}
}
} else
{}
}
break;
}
{
var G__13956 = cljs.core.next.call(null,seq__13885_13928__$1);
var G__13957 = null;
var G__13958 = 0;
var G__13959 = 0;
seq__13885_13897 = G__13956;
chunk__13890_13898 = G__13957;
count__13891_13899 = G__13958;
i__13892_13900 = G__13959;
continue;
}
}
} else
{}
}
break;
}
return cljs.core.persistent_BANG_.call(null,cljs.core.deref.call(null,result));
});
lt.object.specificity_sort = (function() {
var specificity_sort = null;
var specificity_sort__1 = (function (xs){return specificity_sort.call(null,xs,null);
});
var specificity_sort__2 = (function (xs,dir){var arr = [];var seq__13964_13968 = cljs.core.seq.call(null,xs);var chunk__13965_13969 = null;var count__13966_13970 = 0;var i__13967_13971 = 0;while(true){
if((i__13967_13971 < count__13966_13970))
{var x_13972 = cljs.core._nth.call(null,chunk__13965_13969,i__13967_13971);arr.push([[cljs.core.str(x_13972)].join('').split(".").length,[cljs.core.str(x_13972)].join(''),x_13972]);
{
var G__13973 = seq__13964_13968;
var G__13974 = chunk__13965_13969;
var G__13975 = count__13966_13970;
var G__13976 = (i__13967_13971 + 1);
seq__13964_13968 = G__13973;
chunk__13965_13969 = G__13974;
count__13966_13970 = G__13975;
i__13967_13971 = G__13976;
continue;
}
} else
{var temp__4092__auto___13977 = cljs.core.seq.call(null,seq__13964_13968);if(temp__4092__auto___13977)
{var seq__13964_13978__$1 = temp__4092__auto___13977;if(cljs.core.chunked_seq_QMARK_.call(null,seq__13964_13978__$1))
{var c__4262__auto___13979 = cljs.core.chunk_first.call(null,seq__13964_13978__$1);{
var G__13980 = cljs.core.chunk_rest.call(null,seq__13964_13978__$1);
var G__13981 = c__4262__auto___13979;
var G__13982 = cljs.core.count.call(null,c__4262__auto___13979);
var G__13983 = 0;
seq__13964_13968 = G__13980;
chunk__13965_13969 = G__13981;
count__13966_13970 = G__13982;
i__13967_13971 = G__13983;
continue;
}
} else
{var x_13984 = cljs.core.first.call(null,seq__13964_13978__$1);arr.push([[cljs.core.str(x_13984)].join('').split(".").length,[cljs.core.str(x_13984)].join(''),x_13984]);
{
var G__13985 = cljs.core.next.call(null,seq__13964_13978__$1);
var G__13986 = null;
var G__13987 = 0;
var G__13988 = 0;
seq__13964_13968 = G__13985;
chunk__13965_13969 = G__13986;
count__13966_13970 = G__13987;
i__13967_13971 = G__13988;
continue;
}
}
} else
{}
}
break;
}
arr.sort();
if(cljs.core.truth_(dir))
{} else
{arr.reverse();
}
var arr__3409__auto___13989 = arr;var i_13990 = 0;while(true){
if((i_13990 < arr__3409__auto___13989.length))
{(arr[i_13990] = (arr[i_13990][2]));
{
var G__13991 = (i_13990 + 1);
i_13990 = G__13991;
continue;
}
} else
{}
break;
}
return arr;
});
specificity_sort = function(xs,dir){
switch(arguments.length){
case 1:
return specificity_sort__1.call(this,xs);
case 2:
return specificity_sort__2.call(this,xs,dir);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
specificity_sort.cljs$core$IFn$_invoke$arity$1 = specificity_sort__1;
specificity_sort.cljs$core$IFn$_invoke$arity$2 = specificity_sort__2;
return specificity_sort;
})()
;
lt.object.ts__GT_negations = (function ts__GT_negations(ts){var seen = (function (){var obj13999 = {};return obj13999;
})();var seq__14000_14004 = cljs.core.seq.call(null,cljs.core.apply.call(null,cljs.core.concat,cljs.core.map.call(null,cljs.core.deref.call(null,lt.object.negated_tags),ts)));var chunk__14001_14005 = null;var count__14002_14006 = 0;var i__14003_14007 = 0;while(true){
if((i__14003_14007 < count__14002_14006))
{var beh_14008 = cljs.core._nth.call(null,chunk__14001_14005,i__14003_14007);(seen[lt.object.__GT_behavior_name.call(null,beh_14008)] = true);
{
var G__14009 = seq__14000_14004;
var G__14010 = chunk__14001_14005;
var G__14011 = count__14002_14006;
var G__14012 = (i__14003_14007 + 1);
seq__14000_14004 = G__14009;
chunk__14001_14005 = G__14010;
count__14002_14006 = G__14011;
i__14003_14007 = G__14012;
continue;
}
} else
{var temp__4092__auto___14013 = cljs.core.seq.call(null,seq__14000_14004);if(temp__4092__auto___14013)
{var seq__14000_14014__$1 = temp__4092__auto___14013;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14000_14014__$1))
{var c__4262__auto___14015 = cljs.core.chunk_first.call(null,seq__14000_14014__$1);{
var G__14016 = cljs.core.chunk_rest.call(null,seq__14000_14014__$1);
var G__14017 = c__4262__auto___14015;
var G__14018 = cljs.core.count.call(null,c__4262__auto___14015);
var G__14019 = 0;
seq__14000_14004 = G__14016;
chunk__14001_14005 = G__14017;
count__14002_14006 = G__14018;
i__14003_14007 = G__14019;
continue;
}
} else
{var beh_14020 = cljs.core.first.call(null,seq__14000_14014__$1);(seen[lt.object.__GT_behavior_name.call(null,beh_14020)] = true);
{
var G__14021 = cljs.core.next.call(null,seq__14000_14014__$1);
var G__14022 = null;
var G__14023 = 0;
var G__14024 = 0;
seq__14000_14004 = G__14021;
chunk__14001_14005 = G__14022;
count__14002_14006 = G__14023;
i__14003_14007 = G__14024;
continue;
}
}
} else
{}
}
break;
}
return seen;
});
lt.object.tags__GT_behaviors = (function tags__GT_behaviors(ts){var duped = cljs.core.apply.call(null,cljs.core.concat,cljs.core.map.call(null,cljs.core.deref.call(null,lt.object.tags),lt.object.specificity_sort.call(null,ts)));var de_duped = cljs.core.reduce.call(null,((function (duped){
return (function (res,cur){if(cljs.core.truth_((new cljs.core.Keyword(null,"seen","seen",1017430509).cljs$core$IFn$_invoke$arity$1(res)[lt.object.__GT_behavior_name.call(null,cur)])))
{return res;
} else
{var beh = lt.object.__GT_behavior.call(null,cur);if(cljs.core.truth_(new cljs.core.Keyword(null,"exclusive","exclusive",2700522000).cljs$core$IFn$_invoke$arity$1(beh)))
{if(cljs.core.coll_QMARK_.call(null,new cljs.core.Keyword(null,"exclusive","exclusive",2700522000).cljs$core$IFn$_invoke$arity$1(beh)))
{var seq__14029_14033 = cljs.core.seq.call(null,new cljs.core.Keyword(null,"exclusive","exclusive",2700522000).cljs$core$IFn$_invoke$arity$1(beh));var chunk__14030_14034 = null;var count__14031_14035 = 0;var i__14032_14036 = 0;while(true){
if((i__14032_14036 < count__14031_14035))
{var exclude_14037 = cljs.core._nth.call(null,chunk__14030_14034,i__14032_14036);(new cljs.core.Keyword(null,"seen","seen",1017430509).cljs$core$IFn$_invoke$arity$1(res)[exclude_14037] = true);
{
var G__14038 = seq__14029_14033;
var G__14039 = chunk__14030_14034;
var G__14040 = count__14031_14035;
var G__14041 = (i__14032_14036 + 1);
seq__14029_14033 = G__14038;
chunk__14030_14034 = G__14039;
count__14031_14035 = G__14040;
i__14032_14036 = G__14041;
continue;
}
} else
{var temp__4092__auto___14042 = cljs.core.seq.call(null,seq__14029_14033);if(temp__4092__auto___14042)
{var seq__14029_14043__$1 = temp__4092__auto___14042;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14029_14043__$1))
{var c__4262__auto___14044 = cljs.core.chunk_first.call(null,seq__14029_14043__$1);{
var G__14045 = cljs.core.chunk_rest.call(null,seq__14029_14043__$1);
var G__14046 = c__4262__auto___14044;
var G__14047 = cljs.core.count.call(null,c__4262__auto___14044);
var G__14048 = 0;
seq__14029_14033 = G__14045;
chunk__14030_14034 = G__14046;
count__14031_14035 = G__14047;
i__14032_14036 = G__14048;
continue;
}
} else
{var exclude_14049 = cljs.core.first.call(null,seq__14029_14043__$1);(new cljs.core.Keyword(null,"seen","seen",1017430509).cljs$core$IFn$_invoke$arity$1(res)[exclude_14049] = true);
{
var G__14050 = cljs.core.next.call(null,seq__14029_14043__$1);
var G__14051 = null;
var G__14052 = 0;
var G__14053 = 0;
seq__14029_14033 = G__14050;
chunk__14030_14034 = G__14051;
count__14031_14035 = G__14052;
i__14032_14036 = G__14053;
continue;
}
}
} else
{}
}
break;
}
} else
{}
(new cljs.core.Keyword(null,"seen","seen",1017430509).cljs$core$IFn$_invoke$arity$1(res)[lt.object.__GT_behavior_name.call(null,cur)] = true);
} else
{}
cljs.core.conj_BANG_.call(null,new cljs.core.Keyword(null,"final","final",1111340264).cljs$core$IFn$_invoke$arity$1(res),cur);
return res;
}
});})(duped))
,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"seen","seen",1017430509),lt.object.ts__GT_negations.call(null,ts),new cljs.core.Keyword(null,"final","final",1111340264),cljs.core.transient$.call(null,cljs.core.PersistentVector.EMPTY)], null),duped);return cljs.core.reverse.call(null,cljs.core.persistent_BANG_.call(null,new cljs.core.Keyword(null,"final","final",1111340264).cljs$core$IFn$_invoke$arity$1(de_duped)));
});
lt.object.trigger__GT_behaviors = (function trigger__GT_behaviors(trig,ts){return cljs.core.get.call(null,lt.object.__GT_triggers.call(null,lt.object.tags__GT_behaviors.call(null,ts)),trig);
});
lt.object.safe_report_error = (function safe_report_error(e){if(cljs.core.truth_(lt.objs.console))
{return lt.objs.console.error(e);
} else
{return console.error(((typeof e === 'string')?e:e.stack));
}
});
lt.object.raise_STAR_ = (function() {
var raise_STAR_ = null;
var raise_STAR___3 = (function (obj,reactions,args){return raise_STAR_.call(null,obj,reactions,args,null);
});
var raise_STAR___4 = (function (obj,reactions,args,trigger){var seq__14068 = cljs.core.seq.call(null,reactions);var chunk__14071 = null;var count__14072 = 0;var i__14073 = 0;while(true){
if((i__14073 < count__14072))
{var r = cljs.core._nth.call(null,chunk__14071,i__14073);var func = new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r));var args__$1 = ((cljs.core.coll_QMARK_.call(null,r))?cljs.core.concat.call(null,cljs.core.rest.call(null,r),args):args);var meta = ((cljs.core.coll_QMARK_.call(null,r))?cljs.core.meta.call(null,r):cljs.core.PersistentArrayMap.EMPTY);if(cljs.core.truth_(func))
{try{var start14077_14082 = (new Date()).getTime();var _STAR_behavior_meta_STAR_14078_14083 = lt.object._STAR_behavior_meta_STAR_;try{lt.object._STAR_behavior_meta_STAR_ = meta;
cljs.core.apply.call(null,func,obj,args__$1);
}finally {lt.object._STAR_behavior_meta_STAR_ = _STAR_behavior_meta_STAR_14078_14083;
}if(cljs.core._EQ_.call(null,trigger,new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588)))
{} else
{lt.object.raise.call(null,obj,new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588),r,((new Date()).getTime() - start14077_14082),trigger);
}
}catch (e14076){var e_14084 = e14076;lt.object.safe_report_error.call(null,[cljs.core.str("Invalid behavior: "),cljs.core.str(new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r)))].join(''));
lt.object.safe_report_error.call(null,e_14084);
}{
var G__14085 = seq__14068;
var G__14086 = chunk__14071;
var G__14087 = count__14072;
var G__14088 = (i__14073 + 1);
seq__14068 = G__14085;
chunk__14071 = G__14086;
count__14072 = G__14087;
i__14073 = G__14088;
continue;
}
} else
{{
var G__14089 = seq__14068;
var G__14090 = chunk__14071;
var G__14091 = count__14072;
var G__14092 = (i__14073 + 1);
seq__14068 = G__14089;
chunk__14071 = G__14090;
count__14072 = G__14091;
i__14073 = G__14092;
continue;
}
}
} else
{var temp__4092__auto__ = cljs.core.seq.call(null,seq__14068);if(temp__4092__auto__)
{var seq__14068__$1 = temp__4092__auto__;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14068__$1))
{var c__4262__auto__ = cljs.core.chunk_first.call(null,seq__14068__$1);{
var G__14093 = cljs.core.chunk_rest.call(null,seq__14068__$1);
var G__14094 = c__4262__auto__;
var G__14095 = cljs.core.count.call(null,c__4262__auto__);
var G__14096 = 0;
seq__14068 = G__14093;
chunk__14071 = G__14094;
count__14072 = G__14095;
i__14073 = G__14096;
continue;
}
} else
{var r = cljs.core.first.call(null,seq__14068__$1);var func = new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r));var args__$1 = ((cljs.core.coll_QMARK_.call(null,r))?cljs.core.concat.call(null,cljs.core.rest.call(null,r),args):args);var meta = ((cljs.core.coll_QMARK_.call(null,r))?cljs.core.meta.call(null,r):cljs.core.PersistentArrayMap.EMPTY);if(cljs.core.truth_(func))
{try{var start14080_14097 = (new Date()).getTime();var _STAR_behavior_meta_STAR_14081_14098 = lt.object._STAR_behavior_meta_STAR_;try{lt.object._STAR_behavior_meta_STAR_ = meta;
cljs.core.apply.call(null,func,obj,args__$1);
}finally {lt.object._STAR_behavior_meta_STAR_ = _STAR_behavior_meta_STAR_14081_14098;
}if(cljs.core._EQ_.call(null,trigger,new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588)))
{} else
{lt.object.raise.call(null,obj,new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588),r,((new Date()).getTime() - start14080_14097),trigger);
}
}catch (e14079){var e_14099 = e14079;lt.object.safe_report_error.call(null,[cljs.core.str("Invalid behavior: "),cljs.core.str(new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r)))].join(''));
lt.object.safe_report_error.call(null,e_14099);
}{
var G__14100 = cljs.core.next.call(null,seq__14068__$1);
var G__14101 = null;
var G__14102 = 0;
var G__14103 = 0;
seq__14068 = G__14100;
chunk__14071 = G__14101;
count__14072 = G__14102;
i__14073 = G__14103;
continue;
}
} else
{{
var G__14104 = cljs.core.next.call(null,seq__14068__$1);
var G__14105 = null;
var G__14106 = 0;
var G__14107 = 0;
seq__14068 = G__14104;
chunk__14071 = G__14105;
count__14072 = G__14106;
i__14073 = G__14107;
continue;
}
}
}
} else
{return null;
}
}
break;
}
});
raise_STAR_ = function(obj,reactions,args,trigger){
switch(arguments.length){
case 3:
return raise_STAR___3.call(this,obj,reactions,args);
case 4:
return raise_STAR___4.call(this,obj,reactions,args,trigger);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
raise_STAR_.cljs$core$IFn$_invoke$arity$3 = raise_STAR___3;
raise_STAR_.cljs$core$IFn$_invoke$arity$4 = raise_STAR___4;
return raise_STAR_;
})()
;
/**
* Invoke object's behavior fns for given trigger. Args are passed to behavior fns
* @param {...*} var_args
*/
lt.object.raise = (function() { 
var raise__delegate = function (obj,k,args){var reactions = k.call(null,new cljs.core.Keyword(null,"listeners","listeners",4090152369).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj)));return lt.object.raise_STAR_.call(null,obj,reactions,args,k);
};
var raise = function (obj,k,var_args){
var args = null;if (arguments.length > 2) {
  args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2),0);} 
return raise__delegate.call(this,obj,k,args);};
raise.cljs$lang$maxFixedArity = 2;
raise.cljs$lang$applyTo = (function (arglist__14108){
var obj = cljs.core.first(arglist__14108);
arglist__14108 = cljs.core.next(arglist__14108);
var k = cljs.core.first(arglist__14108);
var args = cljs.core.rest(arglist__14108);
return raise__delegate(obj,k,args);
});
raise.cljs$core$IFn$_invoke$arity$variadic = raise__delegate;
return raise;
})()
;
/**
* For a given behavior keyword id, call its :reaction fn with given args
* @param {...*} var_args
*/
lt.object.call_behavior_reaction = (function() { 
var call_behavior_reaction__delegate = function (id,args){var behavior_fn = new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,id));if(cljs.core.truth_(behavior_fn))
{} else
{throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str(cljs.core.pr_str.call(null,new cljs.core.Symbol(null,"behavior-fn","behavior-fn",-1300659236,null)))].join('')));
}
return cljs.core.apply.call(null,behavior_fn,args);
};
var call_behavior_reaction = function (id,var_args){
var args = null;if (arguments.length > 1) {
  args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return call_behavior_reaction__delegate.call(this,id,args);};
call_behavior_reaction.cljs$lang$maxFixedArity = 1;
call_behavior_reaction.cljs$lang$applyTo = (function (arglist__14109){
var id = cljs.core.first(arglist__14109);
var args = cljs.core.rest(arglist__14109);
return call_behavior_reaction__delegate(id,args);
});
call_behavior_reaction.cljs$core$IFn$_invoke$arity$variadic = call_behavior_reaction__delegate;
return call_behavior_reaction;
})()
;
lt.object.update_listeners = (function() {
var update_listeners = null;
var update_listeners__1 = (function (obj){return update_listeners.call(null,obj,null);
});
var update_listeners__2 = (function (obj,instants){var cur = cljs.core.deref.call(null,obj);var behs = cljs.core.set.call(null,cljs.core.concat.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(cur),lt.object.tags__GT_behaviors.call(null,new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cur))));var trigs = lt.object.__GT_triggers.call(null,behs);var trigs__$1 = (cljs.core.truth_(new cljs.core.Keyword(null,"object.instant-load","object.instant-load",4025433875).cljs$core$IFn$_invoke$arity$1(trigs))?(function (){lt.object.raise_STAR_.call(null,obj,new cljs.core.Keyword(null,"object.instant-load","object.instant-load",4025433875).cljs$core$IFn$_invoke$arity$1(trigs),null,new cljs.core.Keyword(null,"object.instant-load","object.instant-load",4025433875));
return lt.object.__GT_triggers.call(null,behs);
})():trigs);var trigs__$2 = (cljs.core.truth_(instants)?trigs__$1:cljs.core.dissoc.call(null,trigs__$1,new cljs.core.Keyword(null,"object.instant","object.instant",773332388),new cljs.core.Keyword(null,"object.instant-load","object.instant-load",4025433875)));return cljs.core.assoc.call(null,cljs.core.deref.call(null,obj),new cljs.core.Keyword(null,"listeners","listeners",4090152369),trigs__$2);
});
update_listeners = function(obj,instants){
switch(arguments.length){
case 1:
return update_listeners__1.call(this,obj);
case 2:
return update_listeners__2.call(this,obj,instants);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
update_listeners.cljs$core$IFn$_invoke$arity$1 = update_listeners__1;
update_listeners.cljs$core$IFn$_invoke$arity$2 = update_listeners__2;
return update_listeners;
})()
;
/**
* @param {...*} var_args
*/
lt.object.make_object_STAR_ = (function() { 
var make_object_STAR___delegate = function (name,r){var obj = cljs.core.merge.call(null,new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"behaviors","behaviors",607554515),cljs.core.PersistentHashSet.EMPTY,new cljs.core.Keyword(null,"tags","tags",1017456523),cljs.core.PersistentHashSet.EMPTY,new cljs.core.Keyword(null,"triggers","triggers",2516997421),cljs.core.PersistentVector.EMPTY,new cljs.core.Keyword(null,"listeners","listeners",4090152369),cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword("lt.object","type","lt.object/type",701613666),name,new cljs.core.Keyword(null,"children","children",2673430897),cljs.core.PersistentArrayMap.EMPTY], null),cljs.core.apply.call(null,cljs.core.hash_map,r));return obj;
};
var make_object_STAR_ = function (name,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return make_object_STAR___delegate.call(this,name,r);};
make_object_STAR_.cljs$lang$maxFixedArity = 1;
make_object_STAR_.cljs$lang$applyTo = (function (arglist__14110){
var name = cljs.core.first(arglist__14110);
var r = cljs.core.rest(arglist__14110);
return make_object_STAR___delegate(name,r);
});
make_object_STAR_.cljs$core$IFn$_invoke$arity$variadic = make_object_STAR___delegate;
return make_object_STAR_;
})()
;
lt.object.store_object_STAR_ = (function store_object_STAR_(obj){lt.object.add.call(null,obj);
return obj;
});
/**
* Return all objects for given type (template name)
*/
lt.object.instances_by_type = (function instances_by_type(type){return cljs.core.filter.call(null,(function (p1__14111_SHARP_){return cljs.core._EQ_.call(null,type,new cljs.core.Keyword("lt.object","type","lt.object/type",701613666).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,p1__14111_SHARP_)));
}),cljs.core.vals.call(null,cljs.core.deref.call(null,lt.object.instances)));
});
/**
* Merge map into object
*/
lt.object.merge_BANG_ = (function merge_BANG_(obj,m){if(cljs.core.truth_((function (){var and__3508__auto__ = m;if(cljs.core.truth_(and__3508__auto__))
{return !(cljs.core.map_QMARK_.call(null,m));
} else
{return and__3508__auto__;
}
})()))
{throw (new Error([cljs.core.str("Merge requires a map: "),cljs.core.str(m)].join('')));
} else
{}
return cljs.core.swap_BANG_.call(null,obj,cljs.core.merge,m);
});
lt.object.handle_redef = (function handle_redef(odef){var id = new cljs.core.Keyword("lt.object","type","lt.object/type",701613666).cljs$core$IFn$_invoke$arity$1(odef);var seq__14118_14124 = cljs.core.seq.call(null,lt.object.instances_by_type.call(null,id));var chunk__14120_14125 = null;var count__14121_14126 = 0;var i__14122_14127 = 0;while(true){
if((i__14122_14127 < count__14121_14126))
{var o_14128 = cljs.core._nth.call(null,chunk__14120_14125,i__14122_14127);var o_14129__$1 = cljs.core.deref.call(null,o_14128);var args_14130 = new cljs.core.Keyword(null,"args","args",1016906831).cljs$core$IFn$_invoke$arity$1(o_14129__$1);var old_14131 = new cljs.core.Keyword(null,"content","content",1965434859).cljs$core$IFn$_invoke$arity$1(o_14129__$1);var behs_14132 = cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(o_14129__$1));var inst_14133 = cljs.core.deref.call(null,lt.object.instances).call(null,lt.object.__GT_id.call(null,o_14129__$1));var neue_14134 = (cljs.core.truth_(new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(odef))?cljs.core.apply.call(null,new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(odef),inst_14133,args_14130):null);var neue_14135__$1 = ((cljs.core.vector_QMARK_.call(null,neue_14134))?crate.core.html.call(null,neue_14134):neue_14134);lt.object.merge_BANG_.call(null,inst_14133,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"tags","tags",1017456523),clojure.set.union.call(null,new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(o_14129__$1),new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(odef)),new cljs.core.Keyword(null,"behaviors","behaviors",607554515),clojure.set.union.call(null,behs_14132,cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(odef))),new cljs.core.Keyword(null,"content","content",1965434859),neue_14135__$1], null));
lt.object.merge_BANG_.call(null,inst_14133,lt.object.update_listeners.call(null,inst_14133));
if(cljs.core.truth_((function (){var and__3508__auto__ = old_14131;if(cljs.core.truth_(and__3508__auto__))
{return neue_14135__$1;
} else
{return and__3508__auto__;
}
})()))
{lt.util.dom.replace_with.call(null,old_14131,neue_14135__$1);
} else
{}
lt.object.raise.call(null,inst_14133,new cljs.core.Keyword(null,"redef","redef",1122293860));
{
var G__14136 = seq__14118_14124;
var G__14137 = chunk__14120_14125;
var G__14138 = count__14121_14126;
var G__14139 = (i__14122_14127 + 1);
seq__14118_14124 = G__14136;
chunk__14120_14125 = G__14137;
count__14121_14126 = G__14138;
i__14122_14127 = G__14139;
continue;
}
} else
{var temp__4092__auto___14140 = cljs.core.seq.call(null,seq__14118_14124);if(temp__4092__auto___14140)
{var seq__14118_14141__$1 = temp__4092__auto___14140;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14118_14141__$1))
{var c__4262__auto___14142 = cljs.core.chunk_first.call(null,seq__14118_14141__$1);{
var G__14143 = cljs.core.chunk_rest.call(null,seq__14118_14141__$1);
var G__14144 = c__4262__auto___14142;
var G__14145 = cljs.core.count.call(null,c__4262__auto___14142);
var G__14146 = 0;
seq__14118_14124 = G__14143;
chunk__14120_14125 = G__14144;
count__14121_14126 = G__14145;
i__14122_14127 = G__14146;
continue;
}
} else
{var o_14147 = cljs.core.first.call(null,seq__14118_14141__$1);var o_14148__$1 = cljs.core.deref.call(null,o_14147);var args_14149 = new cljs.core.Keyword(null,"args","args",1016906831).cljs$core$IFn$_invoke$arity$1(o_14148__$1);var old_14150 = new cljs.core.Keyword(null,"content","content",1965434859).cljs$core$IFn$_invoke$arity$1(o_14148__$1);var behs_14151 = cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(o_14148__$1));var inst_14152 = cljs.core.deref.call(null,lt.object.instances).call(null,lt.object.__GT_id.call(null,o_14148__$1));var neue_14153 = (cljs.core.truth_(new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(odef))?cljs.core.apply.call(null,new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(odef),inst_14152,args_14149):null);var neue_14154__$1 = ((cljs.core.vector_QMARK_.call(null,neue_14153))?crate.core.html.call(null,neue_14153):neue_14153);lt.object.merge_BANG_.call(null,inst_14152,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"tags","tags",1017456523),clojure.set.union.call(null,new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(o_14148__$1),new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(odef)),new cljs.core.Keyword(null,"behaviors","behaviors",607554515),clojure.set.union.call(null,behs_14151,cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(odef))),new cljs.core.Keyword(null,"content","content",1965434859),neue_14154__$1], null));
lt.object.merge_BANG_.call(null,inst_14152,lt.object.update_listeners.call(null,inst_14152));
if(cljs.core.truth_((function (){var and__3508__auto__ = old_14150;if(cljs.core.truth_(and__3508__auto__))
{return neue_14154__$1;
} else
{return and__3508__auto__;
}
})()))
{lt.util.dom.replace_with.call(null,old_14150,neue_14154__$1);
} else
{}
lt.object.raise.call(null,inst_14152,new cljs.core.Keyword(null,"redef","redef",1122293860));
{
var G__14155 = cljs.core.next.call(null,seq__14118_14141__$1);
var G__14156 = null;
var G__14157 = 0;
var G__14158 = 0;
seq__14118_14124 = G__14155;
chunk__14120_14125 = G__14156;
count__14121_14126 = G__14157;
i__14122_14127 = G__14158;
continue;
}
}
} else
{}
}
break;
}
return id;
});
/**
* Create object template (type) given keyword name and key-value pairs.
* These pairs serve as default attributes for an object. Following keys
* have special meaning:
* 
* * :behaviors - Set of object's behaviors
* * :tags - Set of object's tags
* * :triggers - Set of object's triggers
* * :init - Init fn called when object is created. Fn's return value
* is hiccup html content and saved to :content
* * :listeners (internal) - Map of triggers to vectors of behaviors
* @param {...*} var_args
*/
lt.object.object_STAR_ = (function() { 
var object_STAR___delegate = function (name,r){return lt.object.handle_redef.call(null,lt.object.store_object_STAR_.call(null,cljs.core.apply.call(null,lt.object.make_object_STAR_,name,r)));
};
var object_STAR_ = function (name,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return object_STAR___delegate.call(this,name,r);};
object_STAR_.cljs$lang$maxFixedArity = 1;
object_STAR_.cljs$lang$applyTo = (function (arglist__14159){
var name = cljs.core.first(arglist__14159);
var r = cljs.core.rest(arglist__14159);
return object_STAR___delegate(name,r);
});
object_STAR_.cljs$core$IFn$_invoke$arity$variadic = object_STAR___delegate;
return object_STAR_;
})()
;
/**
* @param {...*} var_args
*/
lt.object.make_behavior_STAR_ = (function() { 
var make_behavior_STAR___delegate = function (name,r){var be = cljs.core.merge.call(null,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"name","name",1017277949),name], null),cljs.core.apply.call(null,cljs.core.hash_map,r));return be;
};
var make_behavior_STAR_ = function (name,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return make_behavior_STAR___delegate.call(this,name,r);};
make_behavior_STAR_.cljs$lang$maxFixedArity = 1;
make_behavior_STAR_.cljs$lang$applyTo = (function (arglist__14160){
var name = cljs.core.first(arglist__14160);
var r = cljs.core.rest(arglist__14160);
return make_behavior_STAR___delegate(name,r);
});
make_behavior_STAR_.cljs$core$IFn$_invoke$arity$variadic = make_behavior_STAR___delegate;
return make_behavior_STAR_;
})()
;
lt.object.store_behavior_STAR_ = (function store_behavior_STAR_(beh){lt.object.add_behavior.call(null,beh);
return new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(beh);
});
lt.object.wrap_throttle = (function wrap_throttle(beh){var temp__4090__auto__ = new cljs.core.Keyword(null,"throttle","throttle",2497347228).cljs$core$IFn$_invoke$arity$1(beh);if(cljs.core.truth_(temp__4090__auto__))
{var thr = temp__4090__auto__;return cljs.core.assoc.call(null,beh,new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.util.js.throttle.call(null,thr,new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(beh)));
} else
{return beh;
}
});
lt.object.wrap_debounce = (function wrap_debounce(beh){var temp__4090__auto__ = new cljs.core.Keyword(null,"debounce","debounce",1556599227).cljs$core$IFn$_invoke$arity$1(beh);if(cljs.core.truth_(temp__4090__auto__))
{var thr = temp__4090__auto__;return cljs.core.assoc.call(null,beh,new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.util.js.debounce.call(null,thr,new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(beh)));
} else
{return beh;
}
});
/**
* @param {...*} var_args
*/
lt.object.behavior_STAR_ = (function() { 
var behavior_STAR___delegate = function (name,r){return lt.object.store_behavior_STAR_.call(null,lt.object.wrap_debounce.call(null,lt.object.wrap_throttle.call(null,cljs.core.apply.call(null,lt.object.make_behavior_STAR_,name,r))));
};
var behavior_STAR_ = function (name,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return behavior_STAR___delegate.call(this,name,r);};
behavior_STAR_.cljs$lang$maxFixedArity = 1;
behavior_STAR_.cljs$lang$applyTo = (function (arglist__14161){
var name = cljs.core.first(arglist__14161);
var r = cljs.core.rest(arglist__14161);
return behavior_STAR___delegate(name,r);
});
behavior_STAR_.cljs$core$IFn$_invoke$arity$variadic = behavior_STAR___delegate;
return behavior_STAR_;
})()
;
/**
* Reduce over invoked object's behavior fns for given trigger. Start
* is initial value for reduce and any args are passed to behavior fn
* @param {...*} var_args
*/
lt.object.raise_reduce = (function() { 
var raise_reduce__delegate = function (obj,k,start,args){var reactions = k.call(null,new cljs.core.Keyword(null,"listeners","listeners",4090152369).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj)));return cljs.core.reduce.call(null,(function (res,cur){var func = new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,cur));var args__$1 = ((cljs.core.coll_QMARK_.call(null,cur))?cljs.core.concat.call(null,cljs.core.rest.call(null,cur),args):args);var meta = ((cljs.core.coll_QMARK_.call(null,cur))?cljs.core.meta.call(null,cur):cljs.core.PersistentArrayMap.EMPTY);if(cljs.core.not.call(null,func))
{return res;
} else
{var _STAR_behavior_meta_STAR_14163 = lt.object._STAR_behavior_meta_STAR_;try{lt.object._STAR_behavior_meta_STAR_ = meta;
return cljs.core.apply.call(null,func,obj,res,args__$1);
}finally {lt.object._STAR_behavior_meta_STAR_ = _STAR_behavior_meta_STAR_14163;
}}
}),start,reactions);
};
var raise_reduce = function (obj,k,start,var_args){
var args = null;if (arguments.length > 3) {
  args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3),0);} 
return raise_reduce__delegate.call(this,obj,k,start,args);};
raise_reduce.cljs$lang$maxFixedArity = 3;
raise_reduce.cljs$lang$applyTo = (function (arglist__14164){
var obj = cljs.core.first(arglist__14164);
arglist__14164 = cljs.core.next(arglist__14164);
var k = cljs.core.first(arglist__14164);
arglist__14164 = cljs.core.next(arglist__14164);
var start = cljs.core.first(arglist__14164);
var args = cljs.core.rest(arglist__14164);
return raise_reduce__delegate(obj,k,start,args);
});
raise_reduce.cljs$core$IFn$_invoke$arity$variadic = raise_reduce__delegate;
return raise_reduce;
})()
;
/**
* Update object with update-in with [:key], fn and args
* @param {...*} var_args
*/
lt.object.update_BANG_ = (function() { 
var update_BANG___delegate = function (obj,r){return cljs.core.swap_BANG_.call(null,obj,(function (p1__14165_SHARP_){return cljs.core.apply.call(null,cljs.core.update_in,p1__14165_SHARP_,r);
}));
};
var update_BANG_ = function (obj,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return update_BANG___delegate.call(this,obj,r);};
update_BANG_.cljs$lang$maxFixedArity = 1;
update_BANG_.cljs$lang$applyTo = (function (arglist__14166){
var obj = cljs.core.first(arglist__14166);
var r = cljs.core.rest(arglist__14166);
return update_BANG___delegate(obj,r);
});
update_BANG_.cljs$core$IFn$_invoke$arity$variadic = update_BANG___delegate;
return update_BANG_;
})()
;
/**
* Update object with assoc-in for given key and value
*/
lt.object.assoc_in_BANG_ = (function assoc_in_BANG_(obj,k,v){if(cljs.core.truth_((function (){var and__3508__auto__ = k;if(cljs.core.truth_(and__3508__auto__))
{return !(cljs.core.sequential_QMARK_.call(null,k));
} else
{return and__3508__auto__;
}
})()))
{throw (new Error([cljs.core.str("Associate requires a sequence of keys: "),cljs.core.str(k)].join('')));
} else
{}
return cljs.core.swap_BANG_.call(null,obj,(function (p1__14167_SHARP_){return cljs.core.assoc_in.call(null,p1__14167_SHARP_,k,v);
}));
});
lt.object.__GT_inst = (function __GT_inst(o){if(cljs.core.map_QMARK_.call(null,o))
{return cljs.core.deref.call(null,lt.object.instances).call(null,lt.object.__GT_id.call(null,o));
} else
{if(crate.binding.deref_QMARK_.call(null,o))
{return o;
} else
{if(new cljs.core.Keyword(null,"else","else",1017020587))
{return cljs.core.deref.call(null,lt.object.instances).call(null,o);
} else
{return null;
}
}
}
});
/**
* Return DOM content associated with object
*/
lt.object.__GT_content = (function __GT_content(obj){return new cljs.core.Keyword(null,"content","content",1965434859).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj));
});
/**
* Destroy object by calling its :destroy trigger, removing it from
* cache and removing associated DOM content
*/
lt.object.destroy_BANG_ = (function destroy_BANG_(obj){var temp__4092__auto__ = lt.object.__GT_inst.call(null,obj);if(cljs.core.truth_(temp__4092__auto__))
{var inst = temp__4092__auto__;lt.object.raise.call(null,inst,new cljs.core.Keyword(null,"destroy","destroy",2571277164));
cljs.core.swap_BANG_.call(null,lt.object.instances,cljs.core.dissoc,lt.object.__GT_id.call(null,inst));
if(cljs.core.truth_(lt.object.__GT_content.call(null,obj)))
{lt.util.dom.remove.call(null,lt.object.__GT_content.call(null,obj));
} else
{}
return cljs.core.reset_BANG_.call(null,obj,null);
} else
{return null;
}
});
lt.object.store_inst = (function store_inst(inst){cljs.core.swap_BANG_.call(null,lt.object.instances,cljs.core.assoc,new cljs.core.Keyword("lt.object","id","lt.object/id",706431105).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,inst)),inst);
return inst;
});
/**
* Create object given keyword name of object template or an object template
* and key-value pairs. See object* for special keys.
* During object creation the following happens to object in order:
* 
* * :init fn is called with given args
* * :object.instant trigger is raised
* * :init trigger is raised
* @param {...*} var_args
*/
lt.object.create = (function() { 
var create__delegate = function (obj_name,args){var obj = (((obj_name instanceof cljs.core.Keyword))?cljs.core.deref.call(null,lt.object.object_defs).call(null,obj_name):obj_name);var id = (function (){var or__3520__auto__ = new cljs.core.Keyword("lt.object","id","lt.object/id",706431105).cljs$core$IFn$_invoke$arity$1(obj);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.swap_BANG_.call(null,lt.object.obj_id,cljs.core.inc);
}
})();var inst = cljs.core.atom.call(null,cljs.core.assoc.call(null,cljs.core.dissoc.call(null,obj,new cljs.core.Keyword(null,"init","init",1017141378)),new cljs.core.Keyword("lt.object","id","lt.object/id",706431105),id,new cljs.core.Keyword(null,"args","args",1016906831),args,new cljs.core.Keyword(null,"behaviors","behaviors",607554515),cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(obj)),new cljs.core.Keyword(null,"tags","tags",1017456523),cljs.core.set.call(null,cljs.core.conj.call(null,new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(obj),new cljs.core.Keyword(null,"object","object",4285503153)))));var inst__$1 = lt.object.store_inst.call(null,inst);var _ = lt.object.merge_BANG_.call(null,inst__$1,lt.object.update_listeners.call(null,inst__$1));var content = (cljs.core.truth_(new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(obj))?cljs.core.apply.call(null,new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(obj),inst__$1,args):null);var content__$1 = ((cljs.core.vector_QMARK_.call(null,content))?crate.core.html.call(null,content):content);var final$ = lt.object.merge_BANG_.call(null,inst__$1,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"content","content",1965434859),content__$1], null));cljs.core.add_watch.call(null,inst__$1,new cljs.core.Keyword("lt.object","change","lt.object/change",2456955616),(function (___$1,___$2,___$3,___$4){return lt.object.raise.call(null,inst__$1,new cljs.core.Keyword(null,"object.change","object.change",966833329));
}));
lt.object.raise_STAR_.call(null,inst__$1,lt.object.trigger__GT_behaviors.call(null,new cljs.core.Keyword(null,"object.instant","object.instant",773332388),new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,inst__$1))),null);
lt.object.raise.call(null,inst__$1,new cljs.core.Keyword(null,"init","init",1017141378));
return inst__$1;
};
var create = function (obj_name,var_args){
var args = null;if (arguments.length > 1) {
  args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return create__delegate.call(this,obj_name,args);};
create.cljs$lang$maxFixedArity = 1;
create.cljs$lang$applyTo = (function (arglist__14168){
var obj_name = cljs.core.first(arglist__14168);
var args = cljs.core.rest(arglist__14168);
return create__delegate(obj_name,args);
});
create.cljs$core$IFn$_invoke$arity$variadic = create__delegate;
return create;
})()
;
lt.object.refresh_BANG_ = (function refresh_BANG_(obj){cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
lt.object.raise_STAR_.call(null,obj,lt.object.trigger__GT_behaviors.call(null,new cljs.core.Keyword(null,"object.instant","object.instant",773332388),new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj))),null);
return lt.object.raise.call(null,obj,new cljs.core.Keyword(null,"object.refresh","object.refresh",4196174494));
});
/**
* Add behavior to object and update its listeners
*/
lt.object.add_behavior_BANG_ = (function add_behavior_BANG_(obj,behavior){lt.object.update_BANG_.call(null,obj,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"behaviors","behaviors",607554515)], null),cljs.core.conj,behavior);
return cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
});
/**
* Remove behavior from object and update its listeners
*/
lt.object.rem_behavior_BANG_ = (function rem_behavior_BANG_(obj,behavior){lt.object.update_BANG_.call(null,obj,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"behaviors","behaviors",607554515)], null),(function (p1__14169_SHARP_){return cljs.core.remove.call(null,cljs.core.PersistentHashSet.fromArray([behavior], true),p1__14169_SHARP_);
}));
return cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
});
lt.object.__GT_def = (function __GT_def(def_BAR_name){if(cljs.core.map_QMARK_.call(null,def_BAR_name))
{return def_BAR_name;
} else
{return cljs.core.deref.call(null,lt.object.object_defs).call(null,def_BAR_name);
}
});
/**
* Find object by its unique numerical id
*/
lt.object.by_id = (function by_id(id){if(cljs.core.truth_(id))
{return cljs.core.deref.call(null,lt.object.instances).call(null,id);
} else
{return null;
}
});
/**
* Find objects that have given tag
*/
lt.object.by_tag = (function by_tag(tag){return cljs.core.sort_by.call(null,cljs.core.comp.call(null,new cljs.core.Keyword("lt.object","id","lt.object/id",706431105),cljs.core.deref),cljs.core.filter.call(null,(function (p1__14170_SHARP_){var temp__4092__auto__ = new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,p1__14170_SHARP_));if(cljs.core.truth_(temp__4092__auto__))
{var ts = temp__4092__auto__;return ts.call(null,tag);
} else
{return null;
}
}),cljs.core.vals.call(null,cljs.core.deref.call(null,lt.object.instances))));
});
lt.object.in_tag_QMARK_ = (function in_tag_QMARK_(tag,behavior){return cljs.core.first.call(null,cljs.core.filter.call(null,cljs.core.PersistentHashSet.fromArray([behavior], true),cljs.core.deref.call(null,lt.object.tags).call(null,tag)));
});
/**
* Return truthy if object has tag
*/
lt.object.has_tag_QMARK_ = (function has_tag_QMARK_(obj,tag){return new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj)).call(null,tag);
});
/**
* Add tags to given object and updates effected behaviors and listeners.
* ::tags-added trigger is raised on object after update
*/
lt.object.add_tags = (function add_tags(obj,ts){lt.object.update_BANG_.call(null,obj,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"tags","tags",1017456523)], null),(function (p1__14171_SHARP_){return cljs.core.reduce.call(null,cljs.core.conj,p1__14171_SHARP_,cljs.core.filter.call(null,cljs.core.identity,ts));
}));
cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
lt.object.raise.call(null,obj,new cljs.core.Keyword("lt.object","tags-added","lt.object/tags-added",1756253556),ts);
lt.object.raise_STAR_.call(null,obj,lt.object.trigger__GT_behaviors.call(null,new cljs.core.Keyword(null,"object.instant","object.instant",773332388),ts),null);
return obj;
});
/**
* Remove tags from given object and updates effected behaviors and listeners.
* ::tags-removed trigger is raised on object after update
*/
lt.object.remove_tags = (function remove_tags(obj,ts){var cur = cljs.core.deref.call(null,obj);var behs = cljs.core.apply.call(null,cljs.core.concat,cljs.core.map.call(null,cljs.core.deref.call(null,lt.object.tags),ts));var cur__$1 = cljs.core.update_in.call(null,cljs.core.update_in.call(null,cljs.core.update_in.call(null,cur,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"tags","tags",1017456523)], null),((function (cur,behs){
return (function (p1__14172_SHARP_){return cljs.core.reduce.call(null,cljs.core.disj,p1__14172_SHARP_,ts);
});})(cur,behs))
),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"behaviors","behaviors",607554515)], null),((function (cur,behs){
return (function (p1__14173_SHARP_){return cljs.core.remove.call(null,cljs.core.PersistentHashSet.fromArray([behs], true),p1__14173_SHARP_);
});})(cur,behs))
),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"listeners","listeners",4090152369)], null),((function (cur,behs){
return (function (p1__14174_SHARP_){return cljs.core.apply.call(null,cljs.core.dissoc,p1__14174_SHARP_,ts);
});})(cur,behs))
);lt.object.merge_BANG_.call(null,obj,cur__$1);
cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
lt.object.raise.call(null,obj,new cljs.core.Keyword("lt.object","tags-removed","lt.object/tags-removed",4080090644),ts);
return obj;
});
/**
* Associate behaviors to given tag and refresh objects with given tag
*/
lt.object.tag_behaviors = (function tag_behaviors(tag,behs){cljs.core.swap_BANG_.call(null,lt.object.tags,cljs.core.update_in,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [tag], null),(function (p1__14175_SHARP_){return cljs.core.reduce.call(null,cljs.core.conj,(function (){var or__3520__auto__ = p1__14175_SHARP_;if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.List.EMPTY;
}
})(),behs);
}));
var seq__14180_14184 = cljs.core.seq.call(null,lt.object.by_tag.call(null,tag));var chunk__14181_14185 = null;var count__14182_14186 = 0;var i__14183_14187 = 0;while(true){
if((i__14183_14187 < count__14182_14186))
{var cur_14188 = cljs.core._nth.call(null,chunk__14181_14185,i__14183_14187);lt.object.refresh_BANG_.call(null,cur_14188);
{
var G__14189 = seq__14180_14184;
var G__14190 = chunk__14181_14185;
var G__14191 = count__14182_14186;
var G__14192 = (i__14183_14187 + 1);
seq__14180_14184 = G__14189;
chunk__14181_14185 = G__14190;
count__14182_14186 = G__14191;
i__14183_14187 = G__14192;
continue;
}
} else
{var temp__4092__auto___14193 = cljs.core.seq.call(null,seq__14180_14184);if(temp__4092__auto___14193)
{var seq__14180_14194__$1 = temp__4092__auto___14193;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14180_14194__$1))
{var c__4262__auto___14195 = cljs.core.chunk_first.call(null,seq__14180_14194__$1);{
var G__14196 = cljs.core.chunk_rest.call(null,seq__14180_14194__$1);
var G__14197 = c__4262__auto___14195;
var G__14198 = cljs.core.count.call(null,c__4262__auto___14195);
var G__14199 = 0;
seq__14180_14184 = G__14196;
chunk__14181_14185 = G__14197;
count__14182_14186 = G__14198;
i__14183_14187 = G__14199;
continue;
}
} else
{var cur_14200 = cljs.core.first.call(null,seq__14180_14194__$1);lt.object.refresh_BANG_.call(null,cur_14200);
{
var G__14201 = cljs.core.next.call(null,seq__14180_14194__$1);
var G__14202 = null;
var G__14203 = 0;
var G__14204 = 0;
seq__14180_14184 = G__14201;
chunk__14181_14185 = G__14202;
count__14182_14186 = G__14203;
i__14183_14187 = G__14204;
continue;
}
}
} else
{}
}
break;
}
return cljs.core.deref.call(null,lt.object.tags).call(null,tag);
});
lt.object.remove_tag_behaviors = (function remove_tag_behaviors(tag,behs){cljs.core.swap_BANG_.call(null,lt.object.tags,cljs.core.update_in,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [tag], null),(function (p1__14205_SHARP_){return cljs.core.remove.call(null,cljs.core.set.call(null,behs),(function (){var or__3520__auto__ = p1__14205_SHARP_;if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.List.EMPTY;
}
})());
}));
var seq__14218 = cljs.core.seq.call(null,lt.object.by_tag.call(null,tag));var chunk__14223 = null;var count__14224 = 0;var i__14225 = 0;while(true){
if((i__14225 < count__14224))
{var cur = cljs.core._nth.call(null,chunk__14223,i__14225);var seq__14226_14230 = cljs.core.seq.call(null,behs);var chunk__14227_14231 = null;var count__14228_14232 = 0;var i__14229_14233 = 0;while(true){
if((i__14229_14233 < count__14228_14232))
{var b_14234 = cljs.core._nth.call(null,chunk__14227_14231,i__14229_14233);lt.object.rem_behavior_BANG_.call(null,cur,b_14234);
{
var G__14235 = seq__14226_14230;
var G__14236 = chunk__14227_14231;
var G__14237 = count__14228_14232;
var G__14238 = (i__14229_14233 + 1);
seq__14226_14230 = G__14235;
chunk__14227_14231 = G__14236;
count__14228_14232 = G__14237;
i__14229_14233 = G__14238;
continue;
}
} else
{var temp__4092__auto___14239 = cljs.core.seq.call(null,seq__14226_14230);if(temp__4092__auto___14239)
{var seq__14226_14240__$1 = temp__4092__auto___14239;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14226_14240__$1))
{var c__4262__auto___14241 = cljs.core.chunk_first.call(null,seq__14226_14240__$1);{
var G__14242 = cljs.core.chunk_rest.call(null,seq__14226_14240__$1);
var G__14243 = c__4262__auto___14241;
var G__14244 = cljs.core.count.call(null,c__4262__auto___14241);
var G__14245 = 0;
seq__14226_14230 = G__14242;
chunk__14227_14231 = G__14243;
count__14228_14232 = G__14244;
i__14229_14233 = G__14245;
continue;
}
} else
{var b_14246 = cljs.core.first.call(null,seq__14226_14240__$1);lt.object.rem_behavior_BANG_.call(null,cur,b_14246);
{
var G__14247 = cljs.core.next.call(null,seq__14226_14240__$1);
var G__14248 = null;
var G__14249 = 0;
var G__14250 = 0;
seq__14226_14230 = G__14247;
chunk__14227_14231 = G__14248;
count__14228_14232 = G__14249;
i__14229_14233 = G__14250;
continue;
}
}
} else
{}
}
break;
}
{
var G__14251 = seq__14218;
var G__14252 = chunk__14223;
var G__14253 = count__14224;
var G__14254 = (i__14225 + 1);
seq__14218 = G__14251;
chunk__14223 = G__14252;
count__14224 = G__14253;
i__14225 = G__14254;
continue;
}
} else
{var temp__4092__auto__ = cljs.core.seq.call(null,seq__14218);if(temp__4092__auto__)
{var seq__14218__$1 = temp__4092__auto__;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14218__$1))
{var c__4262__auto__ = cljs.core.chunk_first.call(null,seq__14218__$1);{
var G__14255 = cljs.core.chunk_rest.call(null,seq__14218__$1);
var G__14256 = c__4262__auto__;
var G__14257 = cljs.core.count.call(null,c__4262__auto__);
var G__14258 = 0;
seq__14218 = G__14255;
chunk__14223 = G__14256;
count__14224 = G__14257;
i__14225 = G__14258;
continue;
}
} else
{var cur = cljs.core.first.call(null,seq__14218__$1);var seq__14219_14259 = cljs.core.seq.call(null,behs);var chunk__14220_14260 = null;var count__14221_14261 = 0;var i__14222_14262 = 0;while(true){
if((i__14222_14262 < count__14221_14261))
{var b_14263 = cljs.core._nth.call(null,chunk__14220_14260,i__14222_14262);lt.object.rem_behavior_BANG_.call(null,cur,b_14263);
{
var G__14264 = seq__14219_14259;
var G__14265 = chunk__14220_14260;
var G__14266 = count__14221_14261;
var G__14267 = (i__14222_14262 + 1);
seq__14219_14259 = G__14264;
chunk__14220_14260 = G__14265;
count__14221_14261 = G__14266;
i__14222_14262 = G__14267;
continue;
}
} else
{var temp__4092__auto___14268__$1 = cljs.core.seq.call(null,seq__14219_14259);if(temp__4092__auto___14268__$1)
{var seq__14219_14269__$1 = temp__4092__auto___14268__$1;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14219_14269__$1))
{var c__4262__auto___14270 = cljs.core.chunk_first.call(null,seq__14219_14269__$1);{
var G__14271 = cljs.core.chunk_rest.call(null,seq__14219_14269__$1);
var G__14272 = c__4262__auto___14270;
var G__14273 = cljs.core.count.call(null,c__4262__auto___14270);
var G__14274 = 0;
seq__14219_14259 = G__14271;
chunk__14220_14260 = G__14272;
count__14221_14261 = G__14273;
i__14222_14262 = G__14274;
continue;
}
} else
{var b_14275 = cljs.core.first.call(null,seq__14219_14269__$1);lt.object.rem_behavior_BANG_.call(null,cur,b_14275);
{
var G__14276 = cljs.core.next.call(null,seq__14219_14269__$1);
var G__14277 = null;
var G__14278 = 0;
var G__14279 = 0;
seq__14219_14259 = G__14276;
chunk__14220_14260 = G__14277;
count__14221_14261 = G__14278;
i__14222_14262 = G__14279;
continue;
}
}
} else
{}
}
break;
}
{
var G__14280 = cljs.core.next.call(null,seq__14218__$1);
var G__14281 = null;
var G__14282 = 0;
var G__14283 = 0;
seq__14218 = G__14280;
chunk__14223 = G__14281;
count__14224 = G__14282;
i__14225 = G__14283;
continue;
}
}
} else
{return null;
}
}
break;
}
});
lt.object.__BEH__add_tag = (function __BEH__add_tag(this$,t){if(cljs.core.truth_(t))
{return lt.object.add_tags.call(null,this$,((cljs.core.coll_QMARK_.call(null,t))?t:new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [t], null)));
} else
{return null;
}
});
lt.object.behavior_STAR_.call(null,new cljs.core.Keyword("lt.object","add-tag","lt.object/add-tag",1703923742),new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.object.__BEH__add_tag,new cljs.core.Keyword(null,"desc","desc",1016984067),"App: Add tag to object",new cljs.core.Keyword(null,"params","params",4313443576),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"label","label",1116631654),"tag"], null)], null),new cljs.core.Keyword(null,"triggers","triggers",2516997421),new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"object.instant","object.instant",773332388),null], null), null),new cljs.core.Keyword(null,"type","type",1017479852),new cljs.core.Keyword(null,"user","user",1017503549));
lt.object.__BEH__remove_tag = (function __BEH__remove_tag(this$,t){if(cljs.core.truth_(lt.object.has_tag_QMARK_.call(null,this$,t)))
{return lt.object.remove_tags.call(null,this$,((cljs.core.coll_QMARK_.call(null,t))?t:new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [t], null)));
} else
{return null;
}
});
lt.object.behavior_STAR_.call(null,new cljs.core.Keyword("lt.object","remove-tag","lt.object/remove-tag",3883925951),new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.object.__BEH__remove_tag,new cljs.core.Keyword(null,"desc","desc",1016984067),"App: Remove tag from object",new cljs.core.Keyword(null,"params","params",4313443576),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"label","label",1116631654),"tag"], null)], null),new cljs.core.Keyword(null,"triggers","triggers",2516997421),new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"object.instant","object.instant",773332388),null,new cljs.core.Keyword("lt.object","tags-added","lt.object/tags-added",1756253556),null], null), null),new cljs.core.Keyword(null,"type","type",1017479852),new cljs.core.Keyword(null,"user","user",1017503549));
lt.object.__BEH__shadow_tag = (function __BEH__shadow_tag(this$,to_shadow,to_add){var has_shadow_QMARK_ = lt.object.has_tag_QMARK_.call(null,this$,to_shadow);var has_add_QMARK_ = lt.object.has_tag_QMARK_.call(null,this$,to_add);if(cljs.core.truth_((function (){var and__3508__auto__ = has_shadow_QMARK_;if(cljs.core.truth_(and__3508__auto__))
{return cljs.core.not.call(null,has_add_QMARK_);
} else
{return and__3508__auto__;
}
})()))
{return lt.object.add_tags.call(null,this$,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [to_add], null));
} else
{if(cljs.core.truth_((function (){var and__3508__auto__ = cljs.core.not.call(null,has_shadow_QMARK_);if(and__3508__auto__)
{return has_add_QMARK_;
} else
{return and__3508__auto__;
}
})()))
{return lt.object.remove_tags.call(null,this$,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [to_add], null));
} else
{if(new cljs.core.Keyword(null,"else","else",1017020587))
{return null;
} else
{return null;
}
}
}
});
lt.object.behavior_STAR_.call(null,new cljs.core.Keyword("lt.object","shadow-tag","lt.object/shadow-tag",1731213395),new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.object.__BEH__shadow_tag,new cljs.core.Keyword(null,"desc","desc",1016984067),"App: Shadow a tag on an object",new cljs.core.Keyword(null,"params","params",4313443576),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"label","label",1116631654),"tag to shadow"], null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"label","label",1116631654),"tag to add"], null)], null),new cljs.core.Keyword(null,"triggers","triggers",2516997421),new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"object.instant","object.instant",773332388),null,new cljs.core.Keyword("lt.object","tags-added","lt.object/tags-added",1756253556),null,new cljs.core.Keyword("lt.object","tags-removed","lt.object/tags-removed",4080090644),null], null), null),new cljs.core.Keyword(null,"type","type",1017479852),new cljs.core.Keyword(null,"user","user",1017503549));
lt.object.__BEH__report_time = (function __BEH__report_time(this$,beh,time,trigger){if(cljs.core.truth_(lt.objs.console))
{return lt.objs.console.log([cljs.core.str(beh),cljs.core.str(" triggered by "),cljs.core.str(trigger),cljs.core.str(" took "),cljs.core.str(time),cljs.core.str("ms")].join(''));
} else
{return null;
}
});
lt.object.behavior_STAR_.call(null,new cljs.core.Keyword("lt.object","report-time","lt.object/report-time",1387009782),new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.object.__BEH__report_time,new cljs.core.Keyword(null,"triggers","triggers",2516997421),new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588),null], null), null));
