// Compiled by ClojureScript 0.0-2138
goog.provide('lt.util.dom');
goog.require('cljs.core');
lt.util.dom.lazy_nl_via_item = (function() {
var lazy_nl_via_item = null;
var lazy_nl_via_item__1 = (function (nl){return lazy_nl_via_item.call(null,nl,0);
});
var lazy_nl_via_item__2 = (function (nl,n){if((n < nl.length))
{return (new cljs.core.LazySeq(null,(function (){return cljs.core.cons.call(null,nl.item(n),lazy_nl_via_item.call(null,nl,(n + 1)));
}),null,null));
} else
{return null;
}
});
lazy_nl_via_item = function(nl,n){
switch(arguments.length){
case 1:
return lazy_nl_via_item__1.call(this,nl);
case 2:
return lazy_nl_via_item__2.call(this,nl,n);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
lazy_nl_via_item.cljs$core$IFn$_invoke$arity$1 = lazy_nl_via_item__1;
lazy_nl_via_item.cljs$core$IFn$_invoke$arity$2 = lazy_nl_via_item__2;
return lazy_nl_via_item;
})()
;
HTMLCollection.prototype.cljs$core$IIndexed$ = true;
HTMLCollection.prototype.cljs$core$IIndexed$_nth$arity$2 = (function (this$,n){var this$__$1 = this;return this$__$1.item(n);
});
HTMLCollection.prototype.cljs$core$IIndexed$_nth$arity$3 = (function (this$,n,not_found){var this$__$1 = this;var or__3520__auto__ = this$__$1.item(n);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return not_found;
}
});
HTMLCollection.prototype.cljs$core$ICounted$ = true;
HTMLCollection.prototype.cljs$core$ICounted$_count$arity$1 = (function (this$){var this$__$1 = this;return this$__$1.length;
});
HTMLCollection.prototype.cljs$core$ISeqable$ = true;
HTMLCollection.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this$){var this$__$1 = this;return lt.util.dom.lazy_nl_via_item.call(null,this$__$1);
});
NodeList.prototype.cljs$core$IIndexed$ = true;
NodeList.prototype.cljs$core$IIndexed$_nth$arity$2 = (function (this$,n){var this$__$1 = this;return this$__$1.item(n);
});
NodeList.prototype.cljs$core$IIndexed$_nth$arity$3 = (function (this$,n,not_found){var this$__$1 = this;var or__3520__auto__ = this$__$1.item(n);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return not_found;
}
});
NodeList.prototype.cljs$core$ICounted$ = true;
NodeList.prototype.cljs$core$ICounted$_count$arity$1 = (function (this$){var this$__$1 = this;return this$__$1.length;
});
NodeList.prototype.cljs$core$ISeqable$ = true;
NodeList.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this$){var this$__$1 = this;return lt.util.dom.lazy_nl_via_item.call(null,this$__$1);
});
lt.util.dom.text_node = (function text_node(text){return document.createTextNode(text);
});
lt.util.dom.$$ = (function() {
var $$ = null;
var $$__1 = (function (query){return $$.call(null,query,document);
});
var $$__2 = (function (query,elem){return elem.querySelectorAll(cljs.core.name.call(null,query));
});
$$ = function(query,elem){
switch(arguments.length){
case 1:
return $$__1.call(this,query);
case 2:
return $$__2.call(this,query,elem);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
$$.cljs$core$IFn$_invoke$arity$1 = $$__1;
$$.cljs$core$IFn$_invoke$arity$2 = $$__2;
return $$;
})()
;
lt.util.dom.$ = (function() {
var $ = null;
var $__1 = (function (query){return $.call(null,query,document);
});
var $__2 = (function (query,elem){return elem.querySelector(cljs.core.name.call(null,query));
});
$ = function(query,elem){
switch(arguments.length){
case 1:
return $__1.call(this,query);
case 2:
return $__2.call(this,query,elem);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
$.cljs$core$IFn$_invoke$arity$1 = $__1;
$.cljs$core$IFn$_invoke$arity$2 = $__2;
return $;
})()
;
lt.util.dom.append = (function append(parent,child){parent.appendChild(child);
return parent;
});
lt.util.dom.prepend = (function prepend(parent,child){if(cljs.core.truth_(parent.firstChild))
{return parent.insertBefore(child,parent.firstChild);
} else
{return lt.util.dom.append.call(null,parent,child);
}
});
lt.util.dom.add_class = (function add_class(elem,class$){if(cljs.core.truth_((function (){var and__3508__auto__ = elem;if(cljs.core.truth_(and__3508__auto__))
{return !(cljs.core.empty_QMARK_.call(null,cljs.core.name.call(null,class$)));
} else
{return and__3508__auto__;
}
})()))
{return elem.classList.add(cljs.core.name.call(null,class$));
} else
{return null;
}
});
lt.util.dom.remove_class = (function remove_class(elem,class$){if(cljs.core.truth_((function (){var and__3508__auto__ = elem;if(cljs.core.truth_(and__3508__auto__))
{return !(cljs.core.empty_QMARK_.call(null,cljs.core.name.call(null,class$)));
} else
{return and__3508__auto__;
}
})()))
{return elem.classList.remove(cljs.core.name.call(null,class$));
} else
{return null;
}
});
lt.util.dom.has_class_QMARK_ = (function has_class_QMARK_(elem,class$){if(cljs.core.truth_((function (){var and__3508__auto__ = elem;if(cljs.core.truth_(and__3508__auto__))
{return !(cljs.core.empty_QMARK_.call(null,cljs.core.name.call(null,class$)));
} else
{return and__3508__auto__;
}
})()))
{return elem.classList.contains(cljs.core.name.call(null,class$));
} else
{return null;
}
});
lt.util.dom.toggle_class = (function toggle_class(elem,class$){if(cljs.core.truth_(lt.util.dom.has_class_QMARK_.call(null,elem,class$)))
{return lt.util.dom.remove_class.call(null,elem,class$);
} else
{return lt.util.dom.add_class.call(null,elem,class$);
}
});
lt.util.dom.set_css = (function set_css(elem,things){var seq__13751 = cljs.core.seq.call(null,things);var chunk__13752 = null;var count__13753 = 0;var i__13754 = 0;while(true){
if((i__13754 < count__13753))
{var vec__13755 = cljs.core._nth.call(null,chunk__13752,i__13754);var k = cljs.core.nth.call(null,vec__13755,0,null);var v = cljs.core.nth.call(null,vec__13755,1,null);(elem.style[cljs.core.name.call(null,k)] = (((v instanceof cljs.core.Keyword))?cljs.core.name.call(null,v):v));
{
var G__13757 = seq__13751;
var G__13758 = chunk__13752;
var G__13759 = count__13753;
var G__13760 = (i__13754 + 1);
seq__13751 = G__13757;
chunk__13752 = G__13758;
count__13753 = G__13759;
i__13754 = G__13760;
continue;
}
} else
{var temp__4092__auto__ = cljs.core.seq.call(null,seq__13751);if(temp__4092__auto__)
{var seq__13751__$1 = temp__4092__auto__;if(cljs.core.chunked_seq_QMARK_.call(null,seq__13751__$1))
{var c__4262__auto__ = cljs.core.chunk_first.call(null,seq__13751__$1);{
var G__13761 = cljs.core.chunk_rest.call(null,seq__13751__$1);
var G__13762 = c__4262__auto__;
var G__13763 = cljs.core.count.call(null,c__4262__auto__);
var G__13764 = 0;
seq__13751 = G__13761;
chunk__13752 = G__13762;
count__13753 = G__13763;
i__13754 = G__13764;
continue;
}
} else
{var vec__13756 = cljs.core.first.call(null,seq__13751__$1);var k = cljs.core.nth.call(null,vec__13756,0,null);var v = cljs.core.nth.call(null,vec__13756,1,null);(elem.style[cljs.core.name.call(null,k)] = (((v instanceof cljs.core.Keyword))?cljs.core.name.call(null,v):v));
{
var G__13765 = cljs.core.next.call(null,seq__13751__$1);
var G__13766 = null;
var G__13767 = 0;
var G__13768 = 0;
seq__13751 = G__13765;
chunk__13752 = G__13766;
count__13753 = G__13767;
i__13754 = G__13768;
continue;
}
}
} else
{return null;
}
}
break;
}
});
lt.util.dom.css = (function css(elem,things){var things__$1 = ((cljs.core._EQ_.call(null,Object,cljs.core.type.call(null,things)))?cljs.core.js__GT_clj.call(null,things):things);if(cljs.core.map_QMARK_.call(null,things__$1))
{return lt.util.dom.set_css.call(null,elem,things__$1);
} else
{return (elem.style[cljs.core.name.call(null,things__$1)]);
}
});
lt.util.dom.set_attr = (function set_attr(elem,things){var seq__13775 = cljs.core.seq.call(null,things);var chunk__13776 = null;var count__13777 = 0;var i__13778 = 0;while(true){
if((i__13778 < count__13777))
{var vec__13779 = cljs.core._nth.call(null,chunk__13776,i__13778);var k = cljs.core.nth.call(null,vec__13779,0,null);var v = cljs.core.nth.call(null,vec__13779,1,null);elem.setAttribute(cljs.core.name.call(null,k),(((v instanceof cljs.core.Keyword))?cljs.core.name.call(null,v):v));
{
var G__13781 = seq__13775;
var G__13782 = chunk__13776;
var G__13783 = count__13777;
var G__13784 = (i__13778 + 1);
seq__13775 = G__13781;
chunk__13776 = G__13782;
count__13777 = G__13783;
i__13778 = G__13784;
continue;
}
} else
{var temp__4092__auto__ = cljs.core.seq.call(null,seq__13775);if(temp__4092__auto__)
{var seq__13775__$1 = temp__4092__auto__;if(cljs.core.chunked_seq_QMARK_.call(null,seq__13775__$1))
{var c__4262__auto__ = cljs.core.chunk_first.call(null,seq__13775__$1);{
var G__13785 = cljs.core.chunk_rest.call(null,seq__13775__$1);
var G__13786 = c__4262__auto__;
var G__13787 = cljs.core.count.call(null,c__4262__auto__);
var G__13788 = 0;
seq__13775 = G__13785;
chunk__13776 = G__13786;
count__13777 = G__13787;
i__13778 = G__13788;
continue;
}
} else
{var vec__13780 = cljs.core.first.call(null,seq__13775__$1);var k = cljs.core.nth.call(null,vec__13780,0,null);var v = cljs.core.nth.call(null,vec__13780,1,null);elem.setAttribute(cljs.core.name.call(null,k),(((v instanceof cljs.core.Keyword))?cljs.core.name.call(null,v):v));
{
var G__13789 = cljs.core.next.call(null,seq__13775__$1);
var G__13790 = null;
var G__13791 = 0;
var G__13792 = 0;
seq__13775 = G__13789;
chunk__13776 = G__13790;
count__13777 = G__13791;
i__13778 = G__13792;
continue;
}
}
} else
{return null;
}
}
break;
}
});
lt.util.dom.attr = (function attr(elem,things){if(cljs.core.map_QMARK_.call(null,things))
{return lt.util.dom.set_attr.call(null,elem,things);
} else
{return elem.getAttribute(cljs.core.name.call(null,things));
}
});
lt.util.dom.parent = (function parent(elem){return elem.parentNode;
});
lt.util.dom.children = (function children(elem){return elem.children;
});
lt.util.dom.remove = (function remove(elem){var temp__4092__auto__ = lt.util.dom.parent.call(null,elem);if(cljs.core.truth_(temp__4092__auto__))
{var p = temp__4092__auto__;return p.removeChild(elem);
} else
{return null;
}
});
lt.util.dom.empty = (function empty(elem){return elem.innerHTML = "";
});
/**
* @param {...*} var_args
*/
lt.util.dom.val = (function() { 
var val__delegate = function (elem,p__13793){var vec__13795 = p__13793;var v = cljs.core.nth.call(null,vec__13795,0,null);if(cljs.core.not.call(null,v))
{return elem.value;
} else
{return elem.value = v;
}
};
var val = function (elem,var_args){
var p__13793 = null;if (arguments.length > 1) {
  p__13793 = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return val__delegate.call(this,elem,p__13793);};
val.cljs$lang$maxFixedArity = 1;
val.cljs$lang$applyTo = (function (arglist__13796){
var elem = cljs.core.first(arglist__13796);
var p__13793 = cljs.core.rest(arglist__13796);
return val__delegate(elem,p__13793);
});
val.cljs$core$IFn$_invoke$arity$variadic = val__delegate;
return val;
})()
;
lt.util.dom.prevent = (function prevent(e){return e.preventDefault();
});
lt.util.dom.stop_propagation = (function stop_propagation(e){return e.stopPropagation();
});
lt.util.dom.siblings = (function siblings(elem){return lt.util.dom.parent.call(null,elem).children;
});
lt.util.dom.parents = (function parents(elem,sel){var root = lt.util.dom.parent.call(null,lt.util.dom.$.call(null,new cljs.core.Keyword(null,"body","body",1016933652)));var p = lt.util.dom.parent.call(null,elem);while(true){
if(cljs.core.truth_((function (){var and__3508__auto__ = p;if(cljs.core.truth_(and__3508__auto__))
{return cljs.core.not_EQ_.call(null,p,root);
} else
{return and__3508__auto__;
}
})()))
{if(cljs.core.truth_(p.webkitMatchesSelector(cljs.core.name.call(null,sel))))
{return p;
} else
{{
var G__13797 = lt.util.dom.parent.call(null,p);
p = G__13797;
continue;
}
}
} else
{return null;
}
break;
}
});
lt.util.dom.next = (function next(elem){return elem.nextElementSibling;
});
lt.util.dom.before = (function before(elem,neue){return lt.util.dom.parent.call(null,elem).insertBefore(neue,elem);
});
lt.util.dom.after = (function after(elem,neue){var temp__4090__auto__ = lt.util.dom.next.call(null,elem);if(cljs.core.truth_(temp__4090__auto__))
{var n = temp__4090__auto__;return lt.util.dom.before.call(null,n,neue);
} else
{return lt.util.dom.append.call(null,lt.util.dom.parent.call(null,elem),neue);
}
});
lt.util.dom.replace_with = (function replace_with(orig,neue){var temp__4092__auto__ = lt.util.dom.parent.call(null,orig);if(cljs.core.truth_(temp__4092__auto__))
{var p = temp__4092__auto__;return p.replaceChild(neue,orig);
} else
{return null;
}
});
lt.util.dom.height = (function height(elem){return elem.clientHeight;
});
lt.util.dom.width = (function width(elem){return elem.clientWidth;
});
lt.util.dom.scroll_width = (function scroll_width(elem){return elem.scrollWidth;
});
lt.util.dom.offset_top = (function offset_top(elem){return elem.offsetTop;
});
/**
* @param {...*} var_args
*/
lt.util.dom.scroll_top = (function() { 
var scroll_top__delegate = function (elem,p__13798){var vec__13800 = p__13798;var v = cljs.core.nth.call(null,vec__13800,0,null);if(cljs.core.not.call(null,v))
{return elem.scrollTop;
} else
{return elem.scrollTop = v;
}
};
var scroll_top = function (elem,var_args){
var p__13798 = null;if (arguments.length > 1) {
  p__13798 = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return scroll_top__delegate.call(this,elem,p__13798);};
scroll_top.cljs$lang$maxFixedArity = 1;
scroll_top.cljs$lang$applyTo = (function (arglist__13801){
var elem = cljs.core.first(arglist__13801);
var p__13798 = cljs.core.rest(arglist__13801);
return scroll_top__delegate(elem,p__13798);
});
scroll_top.cljs$core$IFn$_invoke$arity$variadic = scroll_top__delegate;
return scroll_top;
})()
;
lt.util.dom.top = (function top(elem){return lt.util.dom.css.call(null,elem,new cljs.core.Keyword(null,"top","top",1014019271));
});
lt.util.dom.bottom = (function bottom(elem){return lt.util.dom.css.call(null,elem,new cljs.core.Keyword(null,"bottom","bottom",3925642653));
});
lt.util.dom.left = (function left(elem){return lt.util.dom.css.call(null,elem,new cljs.core.Keyword(null,"left","left",1017222009));
});
lt.util.dom.right = (function right(elem){return lt.util.dom.css.call(null,elem,new cljs.core.Keyword(null,"right","right",1122416014));
});
/**
* @param {...*} var_args
*/
lt.util.dom.html = (function() { 
var html__delegate = function (elem,p__13802){var vec__13804 = p__13802;var h = cljs.core.nth.call(null,vec__13804,0,null);if(cljs.core.not.call(null,h))
{return elem.innerHTML;
} else
{return elem.innerHTML = h;
}
};
var html = function (elem,var_args){
var p__13802 = null;if (arguments.length > 1) {
  p__13802 = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return html__delegate.call(this,elem,p__13802);};
html.cljs$lang$maxFixedArity = 1;
html.cljs$lang$applyTo = (function (arglist__13805){
var elem = cljs.core.first(arglist__13805);
var p__13802 = cljs.core.rest(arglist__13805);
return html__delegate(elem,p__13802);
});
html.cljs$core$IFn$_invoke$arity$variadic = html__delegate;
return html;
})()
;
lt.util.dom.__GT_ev = (function __GT_ev(ev){return [cljs.core.str(cljs.core.name.call(null,ev))].join('');
});
/**
* @param {...*} var_args
*/
lt.util.dom.trigger = (function() { 
var trigger__delegate = function (elem,ev,p__13806){var vec__13808 = p__13806;var opts = cljs.core.nth.call(null,vec__13808,0,null);var e = document.createEvent("HTMLEvents");e.initEvent(cljs.core.name.call(null,ev),true,true);
e.opts = opts;
return elem.dispatchEvent(e);
};
var trigger = function (elem,ev,var_args){
var p__13806 = null;if (arguments.length > 2) {
  p__13806 = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2),0);} 
return trigger__delegate.call(this,elem,ev,p__13806);};
trigger.cljs$lang$maxFixedArity = 2;
trigger.cljs$lang$applyTo = (function (arglist__13809){
var elem = cljs.core.first(arglist__13809);
arglist__13809 = cljs.core.next(arglist__13809);
var ev = cljs.core.first(arglist__13809);
var p__13806 = cljs.core.rest(arglist__13809);
return trigger__delegate(elem,ev,p__13806);
});
trigger.cljs$core$IFn$_invoke$arity$variadic = trigger__delegate;
return trigger;
})()
;
lt.util.dom.on = (function on(elem,ev,cb){return elem.addEventListener(lt.util.dom.__GT_ev.call(null,ev),cb);
});
lt.util.dom.off = (function off(elem,ev,cb){return elem.removeEventListener(lt.util.dom.__GT_ev.call(null,ev),cb);
});
lt.util.dom.on_STAR_ = (function on_STAR_(elem,evs){var seq__13816 = cljs.core.seq.call(null,evs);var chunk__13817 = null;var count__13818 = 0;var i__13819 = 0;while(true){
if((i__13819 < count__13818))
{var vec__13820 = cljs.core._nth.call(null,chunk__13817,i__13819);var ev = cljs.core.nth.call(null,vec__13820,0,null);var cb = cljs.core.nth.call(null,vec__13820,1,null);elem.addEventListener(lt.util.dom.__GT_ev.call(null,ev),cb);
{
var G__13822 = seq__13816;
var G__13823 = chunk__13817;
var G__13824 = count__13818;
var G__13825 = (i__13819 + 1);
seq__13816 = G__13822;
chunk__13817 = G__13823;
count__13818 = G__13824;
i__13819 = G__13825;
continue;
}
} else
{var temp__4092__auto__ = cljs.core.seq.call(null,seq__13816);if(temp__4092__auto__)
{var seq__13816__$1 = temp__4092__auto__;if(cljs.core.chunked_seq_QMARK_.call(null,seq__13816__$1))
{var c__4262__auto__ = cljs.core.chunk_first.call(null,seq__13816__$1);{
var G__13826 = cljs.core.chunk_rest.call(null,seq__13816__$1);
var G__13827 = c__4262__auto__;
var G__13828 = cljs.core.count.call(null,c__4262__auto__);
var G__13829 = 0;
seq__13816 = G__13826;
chunk__13817 = G__13827;
count__13818 = G__13828;
i__13819 = G__13829;
continue;
}
} else
{var vec__13821 = cljs.core.first.call(null,seq__13816__$1);var ev = cljs.core.nth.call(null,vec__13821,0,null);var cb = cljs.core.nth.call(null,vec__13821,1,null);elem.addEventListener(lt.util.dom.__GT_ev.call(null,ev),cb);
{
var G__13830 = cljs.core.next.call(null,seq__13816__$1);
var G__13831 = null;
var G__13832 = 0;
var G__13833 = 0;
seq__13816 = G__13830;
chunk__13817 = G__13831;
count__13818 = G__13832;
i__13819 = G__13833;
continue;
}
}
} else
{return null;
}
}
break;
}
});
lt.util.dom.active_element = (function active_element(){return document.activeElement;
});
lt.util.dom.focus = (function focus(elem){return elem.focus();
});
lt.util.dom.blur = (function blur(elem){return elem.blur();
});
lt.util.dom.selection = (function selection(elem,start,stop,dir){return elem.setSelectionRange(start,stop,dir);
});
lt.util.dom.make = (function make(str){var d = document.createElement("div");lt.util.dom.html.call(null,d,str);
return lt.util.dom.children.call(null,d);
});
lt.util.dom.index = (function index(e){var p = lt.util.dom.parent.call(null,e);var c = (cljs.core.truth_(p)?lt.util.dom.children.call(null,p):[]);var len = c.length;if(cljs.core.not.call(null,p))
{return -1;
} else
{var i = 0;while(true){
if((i >= len))
{return null;
} else
{if(cljs.core._EQ_.call(null,(c[i]),e))
{return i;
} else
{{
var G__13834 = (i + 1);
i = G__13834;
continue;
}
}
}
break;
}
}
});
lt.util.dom.ready = (function ready(func){return lt.util.dom.on.call(null,document,new cljs.core.Keyword(null,"DOMContentLoaded","DOMContentLoaded",3783578446),func);
});
lt.util.dom.fragment = (function fragment(items){var frag = document.createDocumentFragment();var seq__13839_13843 = cljs.core.seq.call(null,items);var chunk__13840_13844 = null;var count__13841_13845 = 0;var i__13842_13846 = 0;while(true){
if((i__13842_13846 < count__13841_13845))
{var i_13847 = cljs.core._nth.call(null,chunk__13840_13844,i__13842_13846);frag.appendChild(i_13847);
{
var G__13848 = seq__13839_13843;
var G__13849 = chunk__13840_13844;
var G__13850 = count__13841_13845;
var G__13851 = (i__13842_13846 + 1);
seq__13839_13843 = G__13848;
chunk__13840_13844 = G__13849;
count__13841_13845 = G__13850;
i__13842_13846 = G__13851;
continue;
}
} else
{var temp__4092__auto___13852 = cljs.core.seq.call(null,seq__13839_13843);if(temp__4092__auto___13852)
{var seq__13839_13853__$1 = temp__4092__auto___13852;if(cljs.core.chunked_seq_QMARK_.call(null,seq__13839_13853__$1))
{var c__4262__auto___13854 = cljs.core.chunk_first.call(null,seq__13839_13853__$1);{
var G__13855 = cljs.core.chunk_rest.call(null,seq__13839_13853__$1);
var G__13856 = c__4262__auto___13854;
var G__13857 = cljs.core.count.call(null,c__4262__auto___13854);
var G__13858 = 0;
seq__13839_13843 = G__13855;
chunk__13840_13844 = G__13856;
count__13841_13845 = G__13857;
i__13842_13846 = G__13858;
continue;
}
} else
{var i_13859 = cljs.core.first.call(null,seq__13839_13853__$1);frag.appendChild(i_13859);
{
var G__13860 = cljs.core.next.call(null,seq__13839_13853__$1);
var G__13861 = null;
var G__13862 = 0;
var G__13863 = 0;
seq__13839_13843 = G__13860;
chunk__13840_13844 = G__13861;
count__13841_13845 = G__13862;
i__13842_13846 = G__13863;
continue;
}
}
} else
{}
}
break;
}
return frag;
});
